import { ConfigurationJSONDefinition } from '../configuration-json-type';
import { Inputs, IO } from '../..';
export declare function printHelp(): never;
interface InputIO extends IO {
    overwrite?: boolean;
}
export declare function getIO(): Partial<InputIO>;
export declare function validateIO(io: Partial<InputIO>): IO;
export interface Package {
    contributes: {
        configuration: {
            type: 'object';
            title: string;
            properties: Record<string, ConfigurationJSONDefinition>;
        };
        commands: {
            command: string;
            title: string;
            enablement?: string;
            icon?: string | {
                dark: string;
                light: string;
            };
        }[];
        keybindings: {
            command: string;
            when?: string;
        }[];
        menus: {
            [menuName: string]: ({
                command: string;
                when?: string;
                group?: string;
            } | {
                submenu: string;
                when?: string;
                group?: string;
            })[];
        };
    };
}
export declare function readInputs(io: IO): Promise<Inputs>;
export {};
