export declare function tryReadFile(filePath: string): Promise<string | null>;
export declare function tryRequire<T>(filePath: string): {
    success: true;
    value: T;
} | {
    success: false;
    error: Error;
};
export declare function tryParseJSON<T>(json: string): T | null;
export declare function exitErr(...errorArgs: unknown[]): never;
export declare function optionalObjectProperty<O extends {
    [K: string]: V | undefined;
}, V>(object: O): {
    [K in keyof O]: O[K] extends undefined ? never : O[K];
};
export declare function fromEntries<T = unknown>(entries: Iterable<readonly [PropertyKey, T]>): {
    [k: string]: T;
};
export declare function fromEntries(entries: Iterable<readonly unknown[]>): unknown;
export declare type DeepPartial<T> = {
    [P in keyof T]?: T[P] extends (infer U)[] ? DeepPartial<U>[] : T[P] extends Record<string, unknown> ? DeepPartial<T[P]> : T[P];
};
